ICPC2018南京网络赛 AC Challenge(一维状压dp)

ICPC2018南京网络赛 AC Challenge

Dlsj is competing in a contest with n(0<n20)n(0<n20)n(0<n20) n ( 0 < n ≤ 20 ) n ( 0 < n ≤ 20 ) n ( 0 < n ≤ 20 ) problems. And he knows the answer of all of these problems.

However, he can submit iii-th problem if and only if he has submitted (and passed, of course) sis_isi​ problems, the pi,1pi,1pi,1th,pi,2pi,2pi,2th,.........,pi,sipi,sipi,sith p i , 1 p i , 1 p i , 1 ​ − t h , p i , 2 p i , 2 p i , 2 ​ − t h , . . . . . . . . . , p i , s i p i , s i p i , s i ​ ​ − t h problem before. (0<pi,jn,0<jsi,0<in)(0<pi,jn,0<jsi,0<in)(0<pi,jn,0<jsi,0<in) ( 0 < p i , j ≤ n , 0 < j ≤ s i , 0 < i ≤ n ) ( 0 < p i , j ≤ n , 0 < j ≤ s i , 0 < i ≤ n ) ( 0 < p i , j ​ ≤ n , 0 < j ≤ s i ​ , 0 < i ≤ n ) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get “Accepted” of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

“I wonder if I can leave the contest arena when the problems are too easy for me.”
“No problem.”
—— CCF NOI Problem set

If he submits and passes the iii-th problem on ttt-th minute(or the ttt-th problem he solve is problem iii), he can get t×ai+bit \times a_i + b_it×ai​+bi​ points. (∣ai∣,∣bi∣≤109)(|a_i|, |b_i| \le 10^9)(∣ai​∣,∣bi​∣≤109).

Your task is to calculate the maximum number of points he can get in the contest.
Input

The first line of input contains an integer, nnn, which is the number of problems.

Then follows nnn lines, the iii-th line contains si+3s_i + 3si​+3 integers, ai,bi,si,p1,p2,…,psia_i,b_i,s_i,p_1,p_2,…,p_{s_i}ai​,bi​,si​,p1​,p2​,…,psi​​as described in the description above.
Output

Output one line with one integer, the maximum number of points he can get in the contest.
Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1×5+6=111 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2×4+5=132 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3×3+4=133 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4×2+3=114 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5×1+2=75 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn’t have to solve all the problems.
样例输入1

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1

55

样例输入2

1
-100 0 0

样例输出2

0

题目来源

ACM-ICPC 2018 南京赛区网络预赛

题意:

给你n个题目,对于每个题目,在做这个题目之前,规定了必须先做哪几个题目,第t个做的题目i得分是 t×ai+bi t × a i + b i 问最终的最大得分是多少?

分析:

因为题目数20很小,可以使用状压dp

用二进制枚举每种状态,对于每种状态首先检查他符不符合要求,即对于每种状态,我们枚举这个状态下做了的题目j,看看要求的在做j之前必须做的题目做了没有,仍然是枚举按位与就可以,如果发现不满足这种状态直接跳过,如果满足大条件,那么我们枚举每个题目,让它当作最后一个题目来做,用异或消去这个题目就得到了当前状态的前一个状态,也就是当前状态有它转移过来,此时更新dp的值即可

code:

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int INF = 0x3f3f3f3f;
const int maxn = 21;
ll a[maxn],b[maxn];
ll dp[1<<20];//dp[i]代表第i中状态下的最大得分
vector<int> v[maxn];//v[i]记录第i个问题之前应该做哪些题目
int main(){
    int n,num,temp;
    scanf("%d",&n);
    for(int i = 1; i <= n; i++){
        scanf("%lld%lld",&a[i],&b[i]);
        scanf("%d",&num);
        while(num--){
            scanf("%d",&temp);
            v[i].push_back(temp);
        }
    }
    memset(dp,0,sizeof(dp));
    for(int i = 0; i < (1 << n); i++){//枚举2^n中状态
        int flag = 0;
        //判断该种状态是否可能存在即判断每个已经做了的题目,要求在这之前必须要做的题目是否也已经做了
        for(int j = 1; j <= n; j++){
            if(!((1 << (j-1)) & i)) continue;//这个题没做就无所谓了
            for(int k = 0; k < v[j].size(); k++){//判断在做题目j之前必须做的题是否已经做了
                if(!((1 << (v[j][k]-1)) & i)){
                    flag = 1;
                    break;
                }
            }
            if(flag) break;
        }
        if(flag) continue;//不满足情况直接跳过
        for(int j = 1; j <= n; j++){
            if(!((1 << (j-1)) & i)) continue;
            int S = i;
            int c = 0;//记录有多少个1,即让问题j第c个做时的状态转移
            while(S){
                if(S & 1) c++;
                S >>= 1;
            }
            dp[i] = max(dp[i],dp[i^(1<<(j-1))]+c*a[j]+b[j]);//让问题j第c个做时从前一个状态转移过来,更新状态i
        }
    }
    printf("%lld\n",dp[(1<<n)-1]);
    return 0;
}
  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值